'My first SDL/openGL FreeBASIC demo
'Relsoft 2004
'Rel.Betterwebber.com

defint a-z

Type Point3d
        x       as single                   'normal 3d coords
        y       as single
        z       as single
        col     as single
end Type

Type polytype
        p1      as integer      'vertex 1 of our triangle
        p2      as integer      'huh?
        p3      as integer
        u1      as single
        v1      as single
        u2      as single
        v2      as single
        u3      as single
        v3      as single
        col     as single
end Type


const PI = 3.141593
const SCR_WIDTH = 320 * 2
const SCR_HEIGHT = 240 * 2
const BPP = 16
const glx = 0.525731112119133606
const glz = .850650808352039932

const TOR_NUM_RINGS = 30
const TOR_NUM_BANDS = 15
const TOR_RING_RAD  = 1.20 * 1
const TOR_BAND_RAD  = .30 * 1



option explicit

'$include: "\sdl\sdl.bi"
'$include: "\gl\gl.bi"
'$include: "\gl\glu.bi"

declare sub drawscene ()
declare sub  LoadTorus (byval Rings as integer, byval Bands as integer,_
                        byval RINGRADIUS as single, byval BandRadius as single,_
                        byref Model() as Point3d, byref Poly() as polytype,_
                        byval Tsize as integer)



    dim shared vertexdat(11, 2) as single
    dim shared vertexcol(19, 2) as single
    dim shared vertexidx(19, 2) as integer
    redim shared Model(1) as Point3d               '3d  Coords
    redim shared ModelTri(1) as PolyType            '3d  Coords

	dim result as unsigned integer
	dim screen as SDL_Surface ptr
	dim i as integer, j as integer
	dim SDL_flags as integer
	dim FOVy as double
	dim Aspect as double
	dim znear as double
	dim zfar as double

    randomize timer

    for i = 0 to 11
        for j = 0 to 2
            read vertexdat(i,j)
        next j
    next i

    for i = 0 to 19
        for j = 0 to 2
            read vertexidx(i,j)
            vertexcol(i,j) = rnd
        next j
    next i
    LoadTorus TOR_NUM_RINGS, TOR_NUM_BANDS, TOR_RING_RAD, TOR_BAND_RAD, model(),_
              modelTri(), 128

    SDL_flags = SDL_HWSURFACE or SDL_DOUBLEBUF or SDL_OPENGL or SDL_OPENGLBLIT 'or SDL_FULLSCREEN
	result = SDL_Init(SDL_INIT_EVERYTHING)
	if result <> 0 then
  		end 1
	end if

	screen = SDL_SetVideoMode(SCR_WIDTH, SCR_HEIGHT, BPP, SDL_flags)
	if screen = 0 then
		SDL_Quit
		end 1
	end if

	SDL_WM_SetCaption "Sdl Test", ""

	glViewport 0, 0, SCR_WIDTH, SCR_HEIGHT
	glMatrixMode GL_PROJECTION
	glLoadIdentity

    FOVy = 80/2
    Aspect = SCR_WIDTH / SCR_HEIGHT
    znear = 5
    zfar = 1000
	gluPerspective FOVy, aspect, znear, zfar

	glMatrixMode GL_MODELVIEW
	glLoadIdentity

	glShadeModel GL_SMOOTH
	glClearColor 0.0, 0.0, 0.0, 0.5
	glClearDepth 1.0
	glEnable GL_DEPTH_TEST
	glDepthFunc GL_LEQUAL
	glEnable GL_COLOR_MATERIAL
	glHint GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST


	do

  		drawscene
		SDL_GL_SwapBuffers

		SDL_PumpEvents
		result = SDL_GetMouseState( byval 0, byval 0 )
	loop while result <> 1

	SDL_Quit

    end

Vertex:
data -glX, 0.0, glZ
data  glX, 0.0, glZ
data -glX, 0.0, -glZ
data  glX, 0.0, -glZ
data  0.0, glZ, glX
data  0.0, glZ, -glX
data  0.0, -glZ, glX
data  0.0, -glZ, -glX
data  glZ, glX, 0.0
data -glZ, glX, 0.0
data  glZ, -glX, 0.0
data -glZ, -glX, 0.0

Indices:
data  0,4,1, 0,9,4, 9,5,4, 4,5,8, 4,8,1
data  8,10,1, 8,3,10, 5,3,8, 5,2,3, 2,7,3
data  7,10,3, 7,6,10, 7,11,6, 11,0,6, 0,1,6
data  6,1,10, 9,0,11, 9,11,2, 9,2,5, 7,2,11




private sub DrawScene
    static theta  as single
    static tortheta  as single
    dim i as integer

    glClear GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT
    glPushMatrix

    glLoadIdentity
    glTranslatef 0.0, 0.0, -10.0
    glScalef 1.5, 1.5, 1.5
    glRotatef theta, 1.0, 0.0, 0.0
    glRotatef theta, 0.0, 1.0, 0.0
    glRotatef theta, 0.0, 0.0, 1.0

   for i = 0 to 19
      glBegin GL_TRIANGLES
    	 glColor3f   vertexcol(i,0), vertexcol(i,1), vertexcol(i,2)
         glVertex3fv vertexdat(vertexidx(i,0),0)
         glColor3f   vertexcol(i,2), vertexcol(i,1), vertexcol(i,0)
         glVertex3fv vertexdat(vertexidx(i,1),0)
         glColor3f   vertexcol(i,2), vertexcol(i,0), vertexcol(i,1)
         glVertex3fv vertexdat(vertexidx(i,2),0)
      glEnd
    next i

    glPopMatrix

    'torus
    glPushMatrix
    glLoadIdentity
    glTranslatef 0.0, 0.0, -10.0
    glScalef 2.5, 2.5, 2.5
    glRotatef tortheta, 1.0, 0.0, 0.0
    glRotatef tortheta, 0.0, 0.0, 1.0
    glRotatef tortheta, 0.0, 1.0, 0.0

    for i = 0 to Ubound(ModelTri)
      glBegin GL_TRIANGLES
    	 glColor3f   Model(ModelTri(i).p1).col, Model(ModelTri(i).p2).col, Model(ModelTri(i).p3).col
         glVertex3fv Model(ModelTri(i).p1).x
         glColor3f   Model(ModelTri(i).p3).col, Model(ModelTri(i).p3).col, Model(ModelTri(i).p1).col
         glVertex3fv Model(ModelTri(i).p2).x
         glColor3f   Model(ModelTri(i).p2).col, Model(ModelTri(i).p1).col, Model(ModelTri(i).p3).col
         glVertex3fv Model(ModelTri(i).p3).x
      glEnd
    next i


    glPopMatrix

    theta  = theta + 1.0
    tortheta  = tortheta + 1.0

end sub


private sub  LoadTorus (byval Rings as integer, byval Bands as integer,_
                        byval RINGRADIUS as single, byval BandRadius as single,_
                        byref Model() as Point3d, byref Poly() as polytype,_
                        byval Tsize as integer)



    dim MaxPoint as integer, i as integer
    dim s1 as integer, s2 as integer
    dim x1 as single, y1 as single, z1 as single
    dim a1 as single, a2 as single
    dim p as single, q as single, r as single

    MaxPoint = Rings * Bands
    redim Model((MaxPoint) - 1) as Point3d

    p = 3
    q = 2
    a1 = 2 * 3.141593 / rings: a2 = 2 * 3.141593 / bands
    i = 0
    for s2 = 0 to bands - 1
        for s1 = 0 to rings - 1
            x1 = cos(s1 * a1) * ringradius
            y1 = sin(s1 * a1) * ringradius
            Model(i).x = x1 + cos(s1 * a1) * cos(s2 * a2) * bandradius
            Model(i).y = y1 + sin(s1 * a1) * cos(s2 * a2) * bandradius
            Model(i).z = sin(s2 * a2) * bandradius
            Model(i).col = rnd
            i = i + 1
        next s1
    next s2

    dim Maxtri as integer
    dim c as integer,t as integer
    i = 0
    maxtri = 0
    for s1 = bands - 1 to 0 step -1
      for s2 = rings - 1 to 0 step -1
        i = i + 1
        maxtri = maxtri + 1
        i = i + 1
        maxtri = maxtri + 1
      next s2
    next s1

    redim Poly(maxtri) as polytype

    i = 0
    for s2 = rings - 1 to 0 step -1
        for s1 = bands - 1 to 0 step -1
          poly(i).p3 = (s1 * rings + s2 + rings) mod maxpoint
          poly(i).p2 = s1 * rings + (s2 + 1) mod rings
          poly(i).p1 = s1 * rings + s2
          poly(i).u1 = tsize
          poly(i).v1 = 0
          poly(i).u2 = 0
          poly(i).v2 = 0
          poly(i).u3 = tsize
          poly(i).v3 = tsize
          poly(i).col = rnd
          i = i + 1
          poly(i).p3 = (s1 * rings + s2 + rings) mod maxpoint
          poly(i).p2 = (s1 * rings + (s2 + 1) mod rings + rings) mod maxpoint
          poly(i).p1 = s1 * rings + (s2 + 1) mod rings
          poly(i).u1 = 0
          poly(i).v1 = 0
          poly(i).u2 = 0
          poly(i).v2 = tsize
          poly(i).u3 = tsize
          poly(i).v3 = tsize
          poly(i).col = rnd
          i = i + 1
        next s1
    next s2


end sub

